#include "vektor.h"
#include "printer.h"
#include "parser.h"
#include "gfanapplication.h"
#include "binomial.h"
#include "latticeideal.h"

class LatticeIdealApplication : public GFanApplication
{
public:
  bool includeInDefaultInstallation()
  {
    return false;
  }
  LatticeIdealApplication()
  {
    registerOptions();
  }
  char *name()
  {
    return "_latticeideal";
  }
  int main()
  {
    FileParser P(Stdin);

    IntegerVectorList ivl=P.parseIntegerVectorList();
    IntegerMatrix A=rowsToIntegerMatrix(ivl);

    IntegerVectorList b=latticeIdealRevLex(A);

    PolynomialSet g;
    for(IntegerVectorList::const_iterator i=b.begin();i!=b.end();i++)
      g.push_back(integerVectorToBinomial(*i));

    AsciiPrinter(Stdout).printPolynomialSet(g);
    return 0;
  }
  const char *helpText()
  {
    return "Computes the lattice ideal of a matrix.\n";
  }
};

static LatticeIdealApplication theApplication;
